import React from 'react';

import useAppState from './useAppState';
import ApiHelper from '../helpers/ApiHelper';
import { useEffectOnce } from '../helpers/Hooks';


export const AppContext = React.createContext();

const AppContextProvider = props => {
  const [state, dispatch] = useAppState();
  const Api = new ApiHelper({ state });


  const getPoolConfig = () => {
    Api.getPoolConfig()
      .then(config => {
        dispatch({ type: 'UPDATE_POOL_CONFIG', config });
        dispatch({ type: 'APP_LOADED', appLoaded: true });
      });
  };

  const actions = {
    getPoolConfig,
  };

  useEffectOnce(() => {
    getPoolConfig();
  })

  return (
    <AppContext.Provider value={{ state, actions }}>
      {state.appSettings.appLoaded && props.children}
    </AppContext.Provider>
  )
};

export default AppContextProvider;
